package football

import (
	"git.lehouerou.net/laurent/sorare/graphql"
)

type So5 struct {
	c *graphql.Client

	So5Fixture     *graphql.Query[So5Fixture, So5FixtureParams]
	So5Fixtures    *graphql.PaginatedQuery[So5Fixture, So5FixturesParams]
	So5Score       *graphql.Query[So5Score, graphql.IdParams]
	So5Leaderboard *graphql.Query[So5Leaderboard, graphql.SlugParams]

	UpcomingLeaderboards *graphql.Query[[]So5Leaderboard, UpcomingLeaderboardsParams]
}

func NewSo5(c *graphql.Client) *So5 {
	return &So5{
		c: c,

		So5Fixture: graphql.NewQuery[So5Fixture, So5FixtureParams](
			c,
			"so5Fixture",
			[]string{"football", "so5"},
		),
		So5Fixtures: graphql.NewPaginatedQuery[So5Fixture, So5FixturesParams](
			c,
			"so5Fixtures",
			[]string{"football", "so5"},
		),
		So5Score: graphql.NewQuery[So5Score, graphql.IdParams](
			c,
			"so5Score",
			[]string{"football", "so5"},
		),
		So5Leaderboard: graphql.NewQuery[So5Leaderboard, graphql.SlugParams](
			c,
			"so5Leaderboard",
			[]string{"football", "so5"},
		),

		UpcomingLeaderboards: graphql.NewQuery[[]So5Leaderboard, UpcomingLeaderboardsParams](
			c,
			"upcomingLeaderboards",
			[]string{"football", "so5"},
		),
	}
}
