package tokens

import (
	"time"

	"github.com/shopspring/decimal"

	"git.lehouerou.net/laurent/sorare/graphql"
	"git.lehouerou.net/laurent/sorare/types"
)

type TokenPrice struct {
	Amount       decimal.Decimal `graphql:"amount"`
	AmountInFiat struct {
		Eur decimal.Decimal `graphql:"eur"`
		Usd decimal.Decimal `graphql:"usd"`
		Gbp decimal.Decimal `graphql:"gbp"`
	} `graphql:"amountInFiat"`
	Amounts MonetaryAmount `graphql:"amounts"`
	Date    time.Time      `graphql:"date"`
	Deal    struct {
		Typename     string `graphql:"__typename"`
		TokenAuction struct {
			Id graphql.Id `graphql:"id"`
		} `graphql:"... on TokenAuction"`
		TokenPrimaryOffer struct {
			Id graphql.Id `graphql:"id"`
		} `graphql:"... on TokenPrimaryOffer"`
		TokenOffer struct {
			Id graphql.Id `graphql:"id"`
		} `graphql:"... on TokenOffer"`
	}
	Id graphql.Id `graphql:"id"`
}

type TokenPricesParams struct {
	Collection types.Collection `graphql:"collection"`
	PlayerSlug string           `graphql:"playerSlug"`
	Rarity     types.Rarity     `graphql:"rarity"`
}
